local e=require"luci.util"
local t=require"luci.http"
local e=require"luci.model.docker"
local e=require"luci.iform"
local a=require"luci.model.runmynas_disk"
module("luci.controller.runmynas",package.seeall)
function index()
entry({"admin","services","runmynas"},call("redirect_index"),_("RunMyNAS"),30).dependent=true
entry({"admin","services","runmynas","pages"},call("runmynas_index")).leaf=true
entry({"admin","services","runmynas","form"},call("runmynas_form"))
entry({"admin","services","runmynas","submit"},call("runmynas_submit"))
end
local e="runmynas"
local o={"admin","services","runmynas","pages"}
function redirect_index()
t.redirect(luci.dispatcher.build_url(unpack(o)))
end
function runmynas_index()
luci.template.render("runmynas/main",{prefix=luci.dispatcher.build_url(unpack(o))})
end
function runmynas_form()
local s=""
local i=""
local n=0
local o=a.blocks()
local e=a.home()
local a,e=a.find_paths(o,e,"Configs")
local e=get_data(e)
local e={
data=e,
schema=get_schema(e,a)
}
local e={
error=s,
scope=i,
success=n,
result=e,
}
t.prepare_content("application/json")
t.write_json(e)
end
function get_schema(t,a)
local e
e={
{
name="build",
text="运行",
type="apply",
},
}
local e={
actions=e,
containers=get_containers(t,a),
description="自定义你的 iStoreNAS，本插件只能运行在 X86 平台，可以去定制其他平台的固件。源码地址：<a href=\"https://github.com/linkease/iStoreNAS\" target=\"_blank\">https://github.com/linkease/iStoreNAS</a>",
title="RunMyNAS"
}
return e
end
function get_containers(t,e)
local e={
main_container(t,e)
}
return e
end
function main_container(t,e)
local t={}
for e,a in pairs(e)do
t[e]=a
end
local e={
properties={
{
name="download",
required=true,
title="源码下载",
type="string",
enum={"github","koolcenter"},
enumNames={"Github","Koolcenter"}
},
{
name="target",
required=true,
title="平台",
type="string",
enum={"x86_64","rk35xx","rk33xx"},
enumNames={"x86_64","rk35xx","rk33xx"}
},
{
name="path",
required=true,
title="运行路径",
type="string",
enum=e,
enumNames=t
},
},
description="请选择合适的平台运行：",
title="运行操作"
}
return e
end
function get_data(i)
local t=require"luci.model.uci".cursor()
local o=t:get_first(e,e,"target","x86_64")
local a=t:get_first(e,e,"download","github")
local e=t:get_first(e,e,"path",i)
local e={
target=o,
download=a,
path=e,
}
return e
end
function runmynas_submit()
local o=""
local i=""
local s=0
local e
local a=require"luci.jsonc"
local n=a.parse
local a=t.content()
local a=n(a)
e=runmynas(a)
t.prepare_content("application/json")
local e={
error=o,
scope=i,
success=s,
result=e,
}
t.write_json(e)
end
function runmynas(t)
local n=t["download"]
local i=t["target"]
local o=t["path"]
local a=require"luci.model.uci".cursor()
a:tset(e,"@"..e.."[0]",{
target=i or"x86_64",
download=n or"github",
path=o,
})
a:save(e)
a:commit(e)
local t=string.format("/usr/libexec/istorec/runmynas.sh %s",t["$apply"])
t="/etc/init.d/tasks task_add runmynas "..luci.util.shellquote(t)
os.execute(t.." >/dev/null 2>&1")
local e={
async=true,
async_state=e
}
return e
end
